#include <WiFi.h>
#include "Wifi.h"
#include "config.h"

#include <esp_err.h>
#include <esp_wifi.h>

bool WatchFeatures::Wifi::Connect()
{
  WiFi.mode(WIFI_STA);
  auto status = WiFi.begin(WIFI_SSID, WIFI_PASS);
  if (status == WL_CONNECT_FAILED) {
    WiFi.mode(WIFI_OFF);
    return false;
  }

  if(WiFi.waitForConnectResult(5000) != WL_CONNECTED) {
    WiFi.mode(WIFI_OFF);
    return false;
  }

  return true;
}

void WatchFeatures::Wifi::Disconnect()
{
  WiFi.mode(WIFI_OFF);
}

bool WatchFeatures::Wifi::IsConnected()
{
  return true;
}

void WatchFeatures::Wifi::InitBoot()
{
  WiFi.mode(WIFI_OFF);
  WiFi.persistent(false);        // prevent the flash storage WiFi credentials
  WiFi.setAutoReconnect(false);  // Set whether module will attempt to reconnect to an access point in case it is disconnected
  WiFi.softAPdisconnect(false);  // kill rogue AP on startup
  WiFi.disconnect(true);
  WiFi.mode(WIFI_STA);

  char country[3];
  esp_wifi_get_country_code(country);
  country[2] = '\0';

  if (strcmp(country, WIFI_COUNTRY_CODE) != 0) {
    esp_wifi_set_country_code(WIFI_COUNTRY_CODE, true);
  }
}